/*
Freezelight Stripe v.0.1
HW - 60 WS2812B LEDs (DIn to D6 pin) placed in line, a button on D3
Железо - 60 WS2812B LED в линейку (DIn к пину D6), кнопка на D3

using Adafruit NeoPixel library

by Artyom Chitailo (sigma72@ya.ru)
*/

#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
  #include <avr/power.h>
#endif

#include <avr/pgmspace.h>
#include "inc_pic.h" //image data array / массив данных картинки

#define PIN 6 // which Arduino pin controls the stripe / пин Ардуино, управляющий лентой

//column display time, milliseconds
//время отображения каждого столбца, мс
#define COL_DELAY 16

Adafruit_NeoPixel strip = Adafruit_NeoPixel(60, PIN, NEO_GRB + NEO_KHZ800);

//gamma correction values
//значения для гамма-функции
byte neopix_gamma[] = {
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,
    1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  2,  2,
    2,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  5,  5,  5,
    5,  6,  6,  6,  6,  7,  7,  7,  7,  8,  8,  8,  9,  9,  9, 10,
   10, 10, 11, 11, 11, 12, 12, 13, 13, 13, 14, 14, 15, 15, 16, 16,
   17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22, 23, 24, 24, 25,
   25, 26, 27, 27, 28, 29, 29, 30, 31, 32, 32, 33, 34, 35, 35, 36,
   37, 38, 39, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 50,
   51, 52, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 66, 67, 68,
   69, 70, 72, 73, 74, 75, 77, 78, 79, 81, 82, 83, 85, 86, 87, 89,
   90, 92, 93, 95, 96, 98, 99,101,102,104,105,107,109,110,112,114,
  115,117,119,120,122,124,126,127,129,131,133,135,137,138,140,142,
  144,146,148,150,152,154,156,158,160,162,164,167,169,171,173,175,
  177,180,182,184,186,189,191,193,196,198,200,203,205,208,210,213,
  215,218,220,223,225,228,231,233,236,239,241,244,247,249,252,255 };

void setup() {
  pinMode(3, INPUT_PULLUP); //button pin / пин для кнопки
  strip.begin();
  //test color wipes
  //тестовые "сосульки"
  colorWipe(strip.Color(255, 0, 0), 2); // Red
  colorWipe(strip.Color(0, 255, 0), 2); // Green
  colorWipe(strip.Color(0, 0, 255), 2); // Blue
  strip.clear();
  strip.show();
  }

void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
    strip.setPixelColor(i, c);
    strip.show();
    delay(wait);
  }
}

//read the array and put it to the LED line
//читаем из массива и выводим на линейку
void showchar() {
 byte R;
 byte G;
 byte B;
 uint16_t fpix; 
  for(int a = 0; a < 90; a++) {
    for(int c = 0; c < 60; c++){
      fpix = pgm_read_word(&(imgdata[a][c]));
      //unpacking 16-bit word to RGB
      //раскидываем 16-битное слово в цвета
      B = lowByte((fpix >> 11) << 3);
      G = lowByte((fpix >> 5) << 2);
      R = lowByte(fpix << 3);
      strip.setPixelColor(c, strip.Color(neopix_gamma[R], neopix_gamma[G], neopix_gamma[B]));
    }
    strip.show();
    delay(COL_DELAY);
  }
strip.clear();
strip.show();
}

void loop() {
  delay(10);
  //wait for button pressed
  //ждем нажатие на кнопку
  if(digitalRead(3) == LOW) {
   showchar();
   }
}
